#include <imsls.h>
#include <stdio.h>
#include <stdlib.h>
int main(){
   int i; 
                   /* number of phenotypes by category               */
   int n_binary=1, n_nominal=2, n_integer=3, n_real=2;
   int n = 40;                      /* population size               */
   int   irandom[1];                /* temporary working storage     */
   float rrandom[1];                /* temporary working storage     */
   int binaryPhenotype[]  = {1};    /* binary phenotype              */
                   /* number of categories for nomial phenotypes     */
   int n_categories[]     = {2, 3};
                   /* nominal phenotype values                       */
   int nominalPhenotype[] = {1, 2};
                   /* number of intervals and boundaries for integer */
                   /* phenotypes                                     */
   int i_intervals[]      = {16, 16, 16};
   int i_bounds[]         = {0, 1000, -10, 10, -20, 0};
                   /* integer phenotype values                       */
   int integerPhenotype[] = {200, -5, -5};
                   /* number of intervals and boundaries for real    */
                   /* phenotypes                                     */
   int r_intervals[]      = {512, 1024};
   float r_bounds[]       = {0.0, 20.0, -20.0, 20.0};
                   /* real phenotype values                          */
   float realPhenotype[]  = {19.9, 19.9};
                   /* fitness array for individuals                  */
   float fitness[40];
                   /* Chromosome Data Structure                      */
   Imsls_f_chromosome* chromosome=NULL;
                   /* Individual Data Structure                      */
   Imsls_f_individual* individuals[40];
                   /* Population Data Structure                      */
   Imsls_f_population* population=NULL;

   chromosome = imsls_f_ga_chromosome(
      IMSLS_BINARY, n_binary,
      IMSLS_NOMINAL, n_nominal, n_categories,
      IMSLS_INTEGER, n_integer, i_intervals, i_bounds,
      IMSLS_REAL,    n_real, r_intervals, r_bounds, 0);

   imsls_random_seed_set(12345);  
                   /* Create individuals                             */
   printf("Creating %d Individuals\n", n);
   for(i=0; i<n; i++){
                   /* generate random values for phenotypes          */
      imsls_f_random_binomial(1, 1, 0.5, 
         IMSLS_RETURN_USER, binaryPhenotype, 0);
      imsls_f_random_uniform_discrete(1, n_categories[0], 
         IMSLS_RETURN_USER, irandom, 0);
      nominalPhenotype[0] = irandom[0]-1;
      imsls_f_random_uniform_discrete(1, n_categories[1], 
         IMSLS_RETURN_USER, irandom, 0);
      nominalPhenotype[1] = irandom[0]-1;
      imsls_f_random_uniform_discrete(1, i_bounds[1]-i_bounds[0], 
         IMSLS_RETURN_USER, irandom, 0);
      integerPhenotype[0] = irandom[0]-1;
      imsls_f_random_uniform_discrete(1, i_bounds[3]-i_bounds[2],
         IMSLS_RETURN_USER, irandom, 0);
      integerPhenotype[1] = irandom[0]-1+i_bounds[2];
      imsls_f_random_uniform_discrete(1, i_bounds[5]-i_bounds[4], 
         IMSLS_RETURN_USER, irandom, 0);
      integerPhenotype[2] = irandom[0]-1+i_bounds[4];
      imsls_f_random_uniform(1, IMSLS_RETURN_USER, rrandom, 0);
      realPhenotype[0] = 
         rrandom[0] * (r_bounds[1]-r_bounds[0]) + r_bounds[0];
      imsls_f_random_uniform(1, IMSLS_RETURN_USER, rrandom, 0);
      realPhenotype[1] = 
         rrandom[0]*(r_bounds[3]-r_bounds[2]) + r_bounds[2];
                   /* create individual from these phenotypes        */
      individuals[i] = imsls_f_ga_individual(chromosome,
         IMSLS_BINARY,  binaryPhenotype,
         IMSLS_NOMINAL, nominalPhenotype,
         IMSLS_INTEGER, integerPhenotype,
         IMSLS_REAL,    realPhenotype, 0);
                   /* calculate fitness for this individual          */
      fitness[i]  = 100.0 + 10*binaryPhenotype[0];
      fitness[i] += 2*nominalPhenotype[1] - 4*nominalPhenotype[0];
      fitness[i] += 0.0001*integerPhenotype[0] +   
         abs(integerPhenotype[1]+integerPhenotype[2])*0.1;
      fitness[i] += 0.1*realPhenotype[0];
      if (realPhenotype[1]>0) fitness[i] += 0.2*realPhenotype[1];
      else  fitness[i] -= 0.2*realPhenotype[1];
   }

   printf("Creating Population from %d Individuals\n", n);

   population = imsls_f_ga_population(n, chromosome, individuals,
      IMSLS_FITNESS, fitness, IMSLS_PRINT, 0);

   imsls_free(chromosome);
   for(i=0; i<n; i++) imsls_f_ga_free_individual(individuals[i]);
   imsls_f_ga_free_population(population);
